<template>
    <div>
        <el-card class="!border-none mb-4" shadow="never">
            <el-form class="mb-[-16px]" :model="queryParams" inline>
                <el-form-item label="方案名称" prop="case_name">
                    <el-input class="w-[280px]" v-model="queryParams.case_name" clearable placeholder="请输入方案名称" />
                </el-form-item>
                <el-form-item label="评审人员" prop="assessor">
                    <el-input class="w-[280px]" v-model="queryParams.assessor" clearable placeholder="请输入评审人员" />
                </el-form-item>
                <el-form-item>
                    <el-button type="primary" @click="resetPage">查询</el-button>
                    <el-button @click="resetParams">重置</el-button>
                </el-form-item>
            </el-form>
        </el-card>
        <el-card class="!border-none" v-loading="pager.loading" shadow="never">
            <el-button v-perms="['supervision_dangerous.supervision_dangerous_engineering_case/add']" type="primary"
                @click="handleAdd">
                <template #icon>
                    <icon name="el-icon-Plus" />
                </template>
                新增
            </el-button>
            <el-button v-perms="['supervision_dangerous.supervision_dangerous_engineering_case/delete']"
                :disabled="!selectData.length" @click="handleDelete(selectData)">
                删除
            </el-button>
            <div class="mt-4">
                <el-table :data="pager.lists" @selection-change="handleSelectionChange">
                    <el-table-column type="selection" width="55" />
                    <el-table-column label="危大工程监控" prop="dangerous_engineering_monitoring_title"
                        show-overflow-tooltip />
                    <el-table-column label="方案名称" prop="case_name" show-overflow-tooltip />
                    <el-table-column label="评审人员" prop="assessor" show-overflow-tooltip />
                    <el-table-column label="分部分项工程" prop="partial_project" show-overflow-tooltip />
                    <el-table-column label="操作" width="150" align="center" fixed="right">

                        <template #default="{ row }">
                            <el-button v-perms="['supervision_dangerous.supervision_dangerous_engineering_case/edit']"
                                type="primary" link @click="handleEdit(row)">
                                编辑
                            </el-button>
                            <el-button v-perms="['supervision_dangerous.supervision_dangerous_engineering_case/delete']"
                                type="danger" link @click="handleDelete(row.id)">
                                删除
                            </el-button>
                            <el-button v-perms="['supervision_dangerous.supervision_dangerous_engineering_case/detail']"
                                link @click="handleDetail(row.id)">
                                详情
                            </el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex mt-4 justify-end">
                <pagination v-model="pager" @change="getLists" />
            </div>
        </el-card>
        <edit-popup v-if="showEdit" ref="editRef" :dict-data="dictData" @success="getLists" @close="showEdit = false" />
        <detailPage v-if="showDetail" ref="detailRef" @close="showEdit = false" :detailConfig="detailConfig"
            width="30vw" :column="1" />
    </div>
</template>

<script lang="ts" setup name="supervisionDangerousEngineeringCaseLists">
import { usePaging } from '@/hooks/usePaging'
import { useDictData } from '@/hooks/useDictOptions'
import { apiSupervisionDangerousEngineeringCaseLists, apiSupervisionDangerousEngineeringCaseDelete, apiSupervisionDangerousEngineeringCaseDetail } from '@/api/supervision_dangerous_engineering_case'
import { timeFormat } from '@/utils/util'
import feedback from '@/utils/feedback'
import EditPopup from './edit.vue'
import { useRoute } from "vue-router"
import { onMounted } from 'vue'
const route = useRoute()
import detailConfig from './detail'

const editRef = shallowRef<InstanceType<typeof EditPopup>>()
const detailRef = ref('')
// 是否显示编辑框
const showEdit = ref(false)
const showDetail = ref(false)



// 查询条件
const queryParams = reactive({
    dangerous_engineering_monitoring_id: '',
    case_name: '',
    assessor: ''
})

// 选中数据
const selectData = ref<any[]>([])

// 表格选择后回调事件
const handleSelectionChange = (val: any[]) => {
    selectData.value = val.map(({ id }) => id)
}

// 获取字典数据
const { dictData } = useDictData('')

// 分页相关
const { pager, getLists, resetParams, resetPage } = usePaging({
    fetchFun: apiSupervisionDangerousEngineeringCaseLists,
    params: queryParams
})

// 添加
const handleAdd = async () => {
    showEdit.value = true
    await nextTick()
    editRef.value?.open('add')
}

// 编辑
const handleEdit = async (data: any) => {
    let res = await apiSupervisionDangerousEngineeringCaseDetail({ id: data.id })
    showEdit.value = true
    await nextTick()
    editRef.value?.open('edit')
    editRef.value?.setFormData(res)
}

// 删除
const handleDelete = async (id: number | any[]) => {
    await feedback.confirm('确定要删除？')
    await apiSupervisionDangerousEngineeringCaseDelete({ id })
    getLists()
}

// 详情
const handleDetail = async (id: any) => {
    let res = await apiSupervisionDangerousEngineeringCaseDetail({ id })
    showDetail.value = true
    await nextTick()
    detailRef.value?.open()
    detailRef.value?.setFormData(res)
}


getLists()

onMounted(async () => {
    if (route.query?.id) {
        showEdit.value = true
        await nextTick()
        editRef.value?.open('add')
        editRef.value?.customEvent(route.query)

    }
})


</script>
